"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Registry = _interopRequireDefault(require("../Registry"));

var _bowerConfig = _interopRequireDefault(require("bower-config"));

var _untildify = _interopRequireDefault(require("untildify"));

var _file = _interopRequireDefault(require("../file"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Bower extends _Registry.default {
  constructor(options = {}) {
    super(options);
    Object.assign(this.options, {
      json: 'bower.json',
      overrides: {},
      componentJson: '.bower.json'
    }, options);

    if (!this.options.dir) {
      var bowerrc = new _bowerConfig.default(this.options.cwd).load().toObject();
      this.options.cwd = (0, _untildify.default)(bowerrc.cwd);
      this.options.dir = (0, _untildify.default)(bowerrc.directory);
    }
  }

  getPackageInfo(packageName, key) {
    let infoPath = _path.default.join(this.getRelativePackagePath(packageName), this.options.componentJson);

    if (!_file.default.exists(infoPath)) {
      infoPath = _path.default.join(this.getRelativePackagePath(packageName), this.options.json);
    }

    let info = {};

    if (_file.default.exists(infoPath)) {
      info = _file.default.readJSON(infoPath);
    }

    if (typeof key !== 'undefined') {
      if (Object.hasOwnProperty.call(info, key)) {
        return info[key];
      }

      return undefined;
    }

    return info;
  }

  getPackageInstallCmd(packageName) {
    return `'bower install ${packageName} --save'`;
  }

}

var _default = Bower;
exports.default = _default;
module.exports = exports.default;