"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Registry = _interopRequireDefault(require("../Registry"));

var _file = _interopRequireDefault(require("../file"));

var _path = _interopRequireDefault(require("path"));

var _configure = _interopRequireDefault(require("../configure"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Npm extends _Registry.default {
  constructor(options = {}) {
    super(options);
    Object.assign(this.options, {
      json: 'package.json',
      overrides: {},
      dir: _configure.default.get(`registry.npm.dir`, 'node_modules')
    }, options);
  }

  getPackageMainFiles(packageName) {
    const info = this.getPackageInfo(packageName);

    if (info && info.main && typeof info.main === 'string') {
      return [info.main];
    }

    return [];
  }

  getPackageInfo(packageName, key) {
    let infoPath = _path.default.join(this.getRelativePackagePath(packageName), this.options.json);

    let info = {};

    if (_file.default.exists(infoPath)) {
      info = _file.default.readJSON(infoPath);
    }

    if (typeof key !== 'undefined') {
      if (Object.hasOwnProperty.call(info, key)) {
        return info[key];
      }

      return undefined;
    }

    return info;
  }

  getPackageInstallCmd(packageName) {
    return `'npm install ${packageName} --save'`;
  }

}

var _default = Npm;
exports.default = _default;
module.exports = exports.default;