"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Singleton = _interopRequireDefault(require("./Singleton"));

var _dotProp = _interopRequireDefault(require("dot-prop"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* It get inspriation from yeoman/configstore */
class Configure extends _Singleton.default {
  constructor() {
    super();
    this.values = {};
  }

  get(key, defaultValue) {
    if (this.has(key)) {
      return _dotProp.default.get(this.values, key);
    }

    return defaultValue;
  }

  set(key, val) {
    let values = this.values;

    if (arguments.length === 1) {
      Object.keys(key).forEach(function (k) {
        _dotProp.default.set(this.values, k, key[k]);
      }.bind(this));
    } else {
      _dotProp.default.set(this.values, key, val);
    }

    this.values = values;
  }

  has(key) {
    return _dotProp.default.has(this.values, key);
  }

  delete(key) {
    let values = this.values;

    _dotProp.default.delete(values, key);

    this.values = values;
  }

  all(values) {
    if (typeof values === 'object') {
      this.values = values;
    } else {
      return this.values;
    }
  }

  size() {
    return Object.keys(this.values).length;
  }

  clear() {
    this.values = {};
    return true;
  }

}

let configure = new Configure();
var _default = configure;
exports.default = _default;
module.exports = exports.default;