"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _minimatch = _interopRequireDefault(require("minimatch"));

var _assert = _interopRequireDefault(require("assert"));

var _toRegExp = _interopRequireDefault(require("./toRegExp"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default(filename, rules) {
  let dirname = _path.default.dirname(filename);

  filename = _path.default.basename(filename);

  for (let glob in rules) {
    if ((0, _minimatch.default)(filename, glob)) {
      if (Array.isArray(rules[glob])) {
        let search = rules[glob][0];
        let replacement = rules[glob][1];
        (0, _assert.default)(typeof replacement === 'string', `The second params of ${glob} should be string`);
        let regex = (0, _toRegExp.default)(search);

        if (regex) {
          return _path.default.join(dirname, filename.replace(regex, replacement));
        }

        return _path.default.join(dirname, filename.split(search).join(replacement));
      }

      return _path.default.join(dirname, rules[glob]);
    }
  }

  return _path.default.join(dirname, filename);
}

module.exports = exports.default;